/************************************************************************
 *   psybnc2.1, src/p_inifunc.c
 *   Copyright (C) 1999 the most psychoid  and
 *                      the cool lam3rz IRC Group, IRCnet
 *			http://www.psychoid.lam3rz.de
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef lint
static char rcsid[] = "@(#)$Id: p_inifunc.c, v 2.1 1999/11/08 02:34:00 psychoid Exp $";
#endif

#define P_INIFUNC

#include <p_global.h>

/* get entry from ini-file */

int getini(char *section, char *param,char *inidat)
{
   char inpuf[200];
   char ppuf[200];
   char spuf[200];
   char buf[4096];    
   int insection;
   FILE *handle;
   char *po;
   pcontext;
   memset(value,0x0,sizeof(value));    
   if ((handle = fopen(inidat,"r")) == NULL) {
      return -1;
   }
   snprintf(ppuf,sizeof(ppuf),"%s=",param);
   insection = 0;       
   snprintf(spuf,sizeof(spuf),"[%s]",section);
   while (fgets(inpuf,sizeof(inpuf),handle)) {
      if (insection == 0) {
         po = strstr(inpuf,spuf);
	 if (po == inpuf) {
 	    insection = 1; /* we are in the desired section */
	 }   
      } else {
         po = strchr(inpuf, '[');
         if (po == inpuf) {
	    
	    fclose(handle);
	    return -2; /* not found */
	 } else {
	   po = strstr(inpuf,ppuf);
	   if (po != NULL) {
	      if (po == inpuf) {	
 	         po = po + strlen(ppuf);
	         snprintf(value,sizeof(value),"%s",nobreak(po));
	         fclose(handle);
	         return 0x0; /* found, returning */
	      }
	   }
	 }
      }            
   }
   /* not found */
   fclose(handle);
   return -2;
}

/* write entry to ini-file or delete if if data = NULL */

int writeini(char *section, char *param, char *inidat, char *data)
{
    char inpuf[200];
    char ppuf[200];
    char spuf[200];
    char tmpfname[200];
    char buf[400];
    char tx[20];
    char *po;
    int insection;
    int wasinsection;
    char *data_p;
    FILE *ini;
    FILE *tmp;
    time_t tm;
    time ( &tm );
   pcontext;
    data_p = data;
    if (data_p != NULL) {
       if (strlen(data) == 0) data_p = NULL;
    }
    snprintf(tx, sizeof(tx),"%s",ctime( &tm ));     
/*    log(section);log(param);log(inidat);log(data);*/
    wasinsection = 0;insection = 0;
    snprintf(tmpfname,sizeof(tmpfname),"%s.TMP",inidat);
    if ((ini = fopen(inidat,"r")) == NULL) {
       if (( ini = fopen(inidat,"w")) == NULL) {	
          return -1;
       }
       snprintf(buf,sizeof(buf),"# created %s\n",tx);
       fprintf(ini,buf);
       fclose(ini);
       if ((ini = fopen(inidat,"r")) == NULL) {	
          return -1;
       }
    }
    if ((tmp = fopen(tmpfname,"w")) == NULL) {
       fclose(ini);
       return -1;
    }
    snprintf(ppuf,sizeof(ppuf),"%s=",param);
    snprintf(spuf,sizeof(spuf),"[%s]",section);
    while (fgets(inpuf,sizeof(inpuf),ini)) {
      if (insection == 0) {
         po = strstr(inpuf,spuf);
         if (po == inpuf) {
	    insection = 1; /* we are in the desired section */
	    wasinsection = 1; /* we had been in the section */
	 }
	 fprintf(tmp,"%s",inpuf);
      } else {
         po = strchr(inpuf, '[');
         if (po == inpuf) {
	    insection = 0;
	    if (data_p != NULL) {
		snprintf(buf,sizeof(buf),"%s=%s",param,data);
		fprintf(tmp,"%s\n",buf);
	    }
	    fprintf(tmp,"%s",inpuf);
	 } else {
	   po = strstr(inpuf,ppuf);
	   if (po == NULL) {
	      fprintf(tmp,"%s",inpuf);
	   }
	 }
      }            
    }
    if (insection == 1) {
      if (data_p != NULL) {
	snprintf(buf,sizeof(buf),"%s=%s",param,data);
	fprintf(tmp,"%s\n",buf);    
      } 
    }
    if (wasinsection == 0) {
      if (data_p != NULL) {
       snprintf(buf,sizeof(buf),"[%s]",section);
       fprintf(tmp,"%s\n",buf);	
       snprintf(buf,sizeof(buf),"%s=%s",param,data);
       fprintf(tmp,"%s\n",buf);	
      } 
    }
    /* not found */
    fclose(tmp);
    fclose(ini);
    rename (tmpfname,inidat);
    return 0x0;
}
/* get server from ini by number */

int getserver(int srvnr, int usernum)
{
   char fnmuser[20];
   char buf[100];
   int ern;
   snprintf(fnmuser,sizeof(fnmuser),"USER%d.INI",usernum);
   snprintf(buf,sizeof(buf),"SERVER%d",srvnr);
   ern = getini("SERVERS",buf,fnmuser);
   if (ern != 0) { return ern; }
   snprintf(user(usernum)->server,sizeof(user(usernum)->server),"%s",value);
   snprintf(buf,sizeof(buf),"PORT%d",srvnr);
   ern = getini("SERVERS",buf,fnmuser);
   if (ern != 0) { user(usernum)->port = 6667; } else { user(usernum)->port = atoi(value); }
   snprintf(buf,sizeof(buf),"SPASS%d",srvnr);
   ern = getini("SERVERS",buf,fnmuser);
   if (ern != 0) { *user(usernum)->spass=0; return 0; }
   snprintf(user(usernum)->spass,sizeof(user(usernum)->spass),"%s",value);
   return 0;
}

/* get next server */

int getnextserver(int nuser)
{
    int first;
   pcontext;
    first = user(nuser)->currentserver;
    while(1)
    {
	user(nuser)->currentserver++;
	if (getserver(user(nuser)->currentserver,nuser) ==0)
	{
	    return 0; /* found it, bye */
	}
	if (user(nuser)->currentserver>20) user(nuser)->currentserver = 0;
	if (user(nuser)->currentserver == first) return -1;
    }
    return 1;
}

/* delete user files */
int deluser(int uind)
{
    char buf[400];
    pcontext;
    snprintf(buf,sizeof(buf),"USER%d.LOG",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.OP",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.ASK",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.BAN",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.DCC",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.LGI",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.AOP",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.TRA",uind);
    oldfile(buf);
    snprintf(buf,sizeof(buf),"USER%d.INI",uind);
    oldfile(buf);
}
