/************************************************************************
 *   psybnc2.1, src/p_sysmsg.c
 *   Copyright (C) 1999 the most psychoid  and
 *                      the cool lam3rz IRC Group, IRCnet
 *			http://www.psychoid.lam3rz.de
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef lint
static char rcsid[] = "@(#)$Id: p_sysmsg.c, v 2.1 1999/11/08 02:34:00 psychoid Exp $";
#endif

#define P_SYSMSG

#include <p_global.h>

#ifdef PARTYCHANNEL

/* partychannel specifics */

int joinparty(int usern)
{
    struct stringarray *lkm;
    snprintf(ircbuf,sizeof(ircbuf),":%s!%s@%s JOIN :" PARTYCHAN "\r\n",user(usern)->nick,
							    user(usern)->login,
							    user(usern)->host);
    writesock(user(usern)->insock,ircbuf);
    snprintf(ircbuf,sizeof(ircbuf),":irc.psychoid.net 332 %s " PARTYCHAN " :%s\r\n",user(usern)->nick,
							    partytopic);
    writesock(user(usern)->insock,ircbuf);
    lkm=partyusers;
    snprintf(ircbuf,sizeof(ircbuf),":irc.psychoid.net 353 %s = " PARTYCHAN " :",user(usern)->nick);
    while(lkm!=NULL)
    {
	if(strlen(ircbuf)>500)
	{
	    strcat(ircbuf,"\r\n");
	    writesock(user(usern)->insock,ircbuf);
	    snprintf(ircbuf,sizeof(ircbuf),":irc.psychoid.net 353 %s = " PARTYCHAN " :",user(usern)->nick);
	}
	strcat(ircbuf,lkm->entry);
	strcat(ircbuf," ");
	lkm=lkm->next;
    }    							    
    strcat(ircbuf,"\r\n");
    writesock(user(usern)->insock,ircbuf);
    snprintf(ircbuf,sizeof(ircbuf),":irc.psychoid.net 366 %s " PARTYCHAN " :End of NAMES list.\r\n",user(usern)->nick);
    writesock(user(usern)->insock,ircbuf);
    snprintf(ircbuf,sizeof(ircbuf),"User %s logged in.",user(usern)->login);
    sysparty(ircbuf);
}

int partyadd(char *xuser)
{
    char buf[200];
    char *pt;
    int rc;
    pt=strchr(xuser,'@');
    if(pt!=NULL) *pt='*';
    rc=partyremove(xuser);
    snprintf(buf,sizeof(buf),"$%s",xuser);
    partyusers=addstring(buf,partyusers);
    return rc;
}

int partyremove(char *xuser)
{
    struct stringarray *lkm,*pre;
    char *pt;
    char buf[200];
    pt=strchr(xuser,'@');
    if(pt!=NULL) *pt='*';
    snprintf(buf,sizeof(buf),"$%s",xuser);
    lkm=partyusers;
    pre=NULL;
    while(lkm!=NULL)
    {
	if (strlen(lkm->entry)==strlen(buf))
	{
	    if(strstr(lkm->entry,buf)==lkm->entry)
	    {
		if(pre!=NULL)
		{
		    pre->next=lkm->next;
		} else {
		    partyusers=lkm->next;
		}
		free(lkm->entry);
		free(lkm);
		return 0; /* old */
	    }
	}
	pre=lkm;
	lkm=lkm->next;
    }
    return 1; /* new */
}

int partylinklost()
{
    struct stringarray *lkm,*pre;
    struct usernodes *th;
    char *pt;
    char buf[200];
    pcontext;
    lkm=partyusers;
    pre=NULL;
    while(lkm!=NULL)
    {
	if(strstr(lkm->entry,"*")!=NULL)
	{
	    if(pre==NULL)
	    { 
		partyusers=lkm->next;
	    } else {
		pre->next=lkm->next;
	    }
	    th=usernode;
	    snprintf(buf,sizeof(buf),"%s!%s. PART " PARTYCHAN " :link loss, rebuilding userlist\r\n",lkm->entry,lkm->entry+1);
	    pt=strchr(buf,'*');
	    if(pt!=NULL)
	    {
		pt++;
		pt=strchr(pt,'*');
		if(pt!=NULL) *pt='@';
	    }
	    while(th!=NULL)
	    {
		if(user(th->uid)->instate>=STD_WHOIS && user(th->uid)->parent==0 && user(th->uid)->sysmsg==1)
		    writesock(user(th->uid)->insock,buf);
		th=th->next;
	    }
	    free(lkm->entry);
	    free(lkm);
	    if(pre==NULL)
		lkm=partyusers;
	    else
		lkm=pre->next;
	} else {
	    pre=lkm;
	    lkm=lkm->next;
	}
    }
    snprintf(ircbuf,sizeof(ircbuf),":*!*@* BWHO :\r\n");
    broadcast(0);
    pcontext;
    return 0; /* new */
}

#endif

int issys=0;

/* querying text to the linked network */

int sysparty(char *txt)
{
    issys=1;
    snprintf(ircto,sizeof(ircto),"%s","$$");
    snprintf(irccontent,sizeof(irccontent),"%s",txt);
    snprintf(nulluser->login,sizeof(nulluser->login),"psyBNC");
    snprintf(nulluser->nick,sizeof(nulluser->nick),"SYS");
    snprintf(irccommand,sizeof(irccommand),"%s","PRIVMSG");
    querybounce(0);
    memset(nulluser,0x0,sizeof(struct usert));
    issys=0;
}


/* sending system notice to a user */

int systemnotice(int usernum,char *text)
{
    char buf[1024];
    if (user(usernum)->instate > 1 && user(usernum)->parent==0) {
       snprintf(buf,sizeof(buf),":psyBNC!psyBNC@lam3rz.de NOTICE %s :%s\n",user(usernum)->nick,text);
       if (inwrite != 1) writesock(user(usernum)->insock,buf);
    }
    return 0x0;
}

/* noticeing all users */

int noticeall (char *what,int adminonly)
{
  struct usernodes *th;    
  int cuuser;
  th=usernode;
  while (th!=NULL) {
     cuuser=th->uid;
     if (adminonly == RI_ADMIN) {
        if (user(cuuser)->rights == RI_ADMIN) {
           systemnotice(cuuser,what);
	}
     } else {
        systemnotice(cuuser,what);
     }
     th=th->next;
  }   
}

/* broadcasting a link message */

int broadcast(int nlink)
{
    struct linknodes *th;    
    int i;
    th=linknode;
    while (th!=NULL)
    {
	i=th->uid;
	if (i!=nlink)
	{
	    if (datalink(i)->type==LI_LINK)
	    {
		if (datalink(i)->outstate==STD_CONN)
		    writesock(datalink(i)->outsock,ircbuf);
	    } else
	    if (datalink(i)->type==LI_ALLOW) {
		if (datalink(i)->instate==STD_CONN)
		    writesock(datalink(i)->insock,ircbuf);
	    }
	}
	th=th->next;
    }
}

/* query to a user on the bounce */

int querybounce(int usern) 
{
    char *po;
    int rc;
    int all;
    int ext;
    char *pt,*pt1,*pt2;
    struct stringarray *lkm,*par;
    char buf[4096];
    char sic[500];
    char sic2[500];
    int rr=0;
    po = ircto;
    po++;
    ext=1;
    if (*po == '$') {
       all=1;
       rc=1;
       snprintf(ircbuf,sizeof(ircbuf),":%s!*@%s PARTY * :%s\r\n",user(usern)->login,me,irccontent);
       broadcast(0);
    } else {
       rc=checkuser(po);
       all=0;
    }   
#ifdef PARTYCHANNEL
    pt=strchr(ircto,'*');
    if (pt!=NULL && *ircto=='$') {
	pt++;
	if(strlen(pt)==strlen(me)&&strstr(pt,me)!=NULL)
	{
	    pt--;
	    *pt=0;
	    rc=checkuser(po);
	} else {
	    pt--;*pt='@'; /* old way compatible */
	    snprintf(ircbuf,sizeof(ircbuf),":%s!*@%s QUERY %s :%s\r\n",user(usern)->login,me,ircto+1,irccontent);
	    broadcast(0);
	    return 0x0;
	}
    }
#else
    pt=strchr(ircto,'@');
    if (pt!=NULL && *ircto=='$') {
	pt++;
	if(strlen(pt)==strlen(me)&&strstr(pt,me)!=NULL)
	{
	    pt--;
	    *pt=0;
	} else {
	    snprintf(ircbuf,sizeof(ircbuf),":%s!*@%s QUERY %s :%s\r\n",user(usern)->login,me,ircto+1,irccontent);
	    broadcast(0);
	    return 0x0;
	}
    }
#endif
    while (ext)
    {
      if (rc) {
	if(user(rc)->instate != STD_CONN && user(rc)->instate != STD_WHOIS) {
	  if (all==0) {
	    snprintf(buf,sizeof(buf),":psyBNC!psyBNC@lam3rz.de NOTICE %s :User %s not on bounce",user(usern)->nick,po);
	    writesock(user(usern)->insock,buf);
	    return 0x0;
	  }
	} else {
	   if (all==1) {
	     if (user(rc)->parent==0) {
#ifdef PARTYCHANNEL
	         /* parsing the systemmessages to JOIN, PART */
		 strcpy(ircto,PARTYCHAN);
		 strcat(ircto," ");
		 snprintf(sic,sizeof(sic),"%s",irccontent);
		 snprintf(sic2,sizeof(sic2),"%s",user(usern)->login);
	         if(strstr(user(usern)->login,"psyBNC")==user(usern)->login)
		 {
		     if (strlen(user(usern)->login)==6)
		     {
		         if(strstr(irccontent,"logged in.")!=NULL)
			 {
			     pt=irccontent+5;
			     pt2=strchr(pt,' ');
			     if(pt2!=NULL)
			     {
			         *pt2=0;
			         strcpy(irccommand,"JOIN");
				 snprintf(user(usern)->login,sizeof(user(usern)->login),"%s",pt);
				 snprintf(buf,sizeof(buf),"%s",pt);
				 if (rr==0) { partyadd(buf);rr=1; }
			     }
			     strcpy(irccontent,PARTYCHAN);
			     *ircto=0;
		         }
			 if(strstr(irccontent,"logged off.")!=NULL)
			 {
			     pt=irccontent+5;
			     pt2=strchr(pt,' ');
			     if(pt2!=NULL)
			     {
			         *pt2=0;
			         strcpy(irccommand,"PART");
				 snprintf(user(usern)->login,sizeof(user(usern)->login),"%s",pt);
				 snprintf(buf,sizeof(buf),"%s",pt);
				 if (rr==0) { partyremove(buf);rr=1; }
			     }
			     strcpy(irccontent,"logged off.");
			 }
			 if(strstr(irccontent,"Lost Link (")==irccontent)
			 {
			     lkm=partyusers;
			     pt=irccontent+11;
			     snprintf(buf,sizeof(buf),"*%s",pt);
			     pt=strchr(buf,')');
			     if(pt!=NULL)*pt=0;
			     par=NULL;
			     while(lkm!=NULL)
			     {
				 pt=strstr(lkm->entry,buf);
				 if(pt==NULL) pt=buf;
			         if(pt!=buf && strlen(pt)==strlen(buf))
				 {
				         snprintf(ircbuf,sizeof(ircbuf),":%s!psyBNC@%s. QUIT :Lost Link\r\n",lkm->entry,lkm->entry+1);
		                         if(user(rc)->sysmsg==1)
					     writesock(user(rc)->insock,ircbuf);
					 if(par==NULL)
					 {
					     partyusers=lkm->next;
					 } else {
					     par->next=lkm->next;
					 }
					 free(lkm->entry);
					 free(lkm);
					 if(par==NULL)
					     lkm=partyusers;
					 else
					     lkm=par->next;
				 } else {
				         par=lkm;
				         lkm=lkm->next;
				 }
			     }
			 }
		     }
		 }
		 if(usern!=rc)
		 {
		     snprintf(buf,sizeof(buf),":$%s!%s@%s. %s %s:%s",user(usern)->login,
		                                             user(usern)->login,me,
		                                             irccommand,ircto,
							     irccontent);
		     if(user(rc)->sysmsg==1)
	                 writesock(user(rc)->insock,buf);
		 }
		 snprintf(user(usern)->login,sizeof(user(usern)->login),"%s",sic2);
		 snprintf(irccontent,sizeof(irccontent),"%s",sic);
#else
		 if((issys==1 && user(rc)->sysmsg==1) || issys==0)
		 {
		     snprintf(buf,sizeof(buf),":$$!psyBNC@lam3rz.de %s %s :[%s] %s",irccommand,
		                                             user(rc)->nick,user(usern)->login,
							     irccontent);
		     if(user(rc)->sysmsg==1)
	                 writesock(user(rc)->insock,buf);
		 }
#endif
	     }
	   } else {    
   	      snprintf(buf,sizeof(buf),":$%s!%s@%s %s %s :%s",user(usern)->login,
	 						   user(usern)->login,
							   me,
							   irccommand,
							   user(rc)->nick,
							   irccontent);
	      writesock(user(rc)->insock,buf);
	   }						   
	}
      } else {
	snprintf(buf,sizeof(buf),":psyBNC!psyBNC@lam3rz.de NOTICE %s :User %s not on bounce",user(usern)->nick,po);
	writesock(user(usern)->insock,buf);
      }  
      if (all==0) ext=0;
      rc++;
      if (rc==MAX_USER) ext=0;  
    }
}

/* query to a dcc bot */

int querybot(int usern) 
{
    struct datalinkt *th;
    char *po;
    int rc;
    char buf[4096];
    int userp;
    if (user(usern)->parent!=0) userp=user(usern)->parent; else userp=usern;
    po = ircto;
    po++;

    th=checkdcc(usern,po);
    if (th==NULL || th->outstate!=STD_CONN)
    {
	snprintf(buf,sizeof(buf),":psyBNC!psyBNC@lam3rz.de NOTICE %s :DCC Connection %s unknown or not established",user(userp)->nick,po);
	writesock(user(usern)->insock,buf);
	return 0x0;
    }
    snprintf(buf,sizeof(buf),"%s\r\n",irccontent);    
    writesock(th->outsock,buf);
}

